#include "extpartition.h"

#include <QUuid>

#include "partition.h"
#include "parentimage.h"

QString ExtPartition::getDevice() const
{
    return device;
}

void ExtPartition::setDevice(const QString &value)
{
    device = value;
}

ExtPartition::ExtPartition(QObject *parent) : Partition(parent)
{
    
}

int ExtPartition::mount(const QString &suPassword, const QString &mountPoint, QTextStream *outputStream)
{
    QProcess *mount = new QProcess;
    mount->setProgram("bash");
    mount->setProcessChannelMode(QProcess::ForwardedChannels);
    mount->start();
    if(!mount->waitForStarted()) throw QString(">>> mount init error!");
    QString mountSuCommand = QString("echo ") + suPassword + QString(" | ") + QString("sudo -S mkdir -p ") + mountPoint + QString("&& echo ") + suPassword + QString(" | ") + QString("sudo -S mount ") + this->device + " " + mountPoint + QString(" && exit \n");
    while (!mount->isOpen());
    mount->write(mountSuCommand.toUtf8());
    if (outputStream != nullptr) {
        *outputStream << "\n> Mounting partition " << this->device << "..." << endl;
    }
    if(!mount->waitForFinished()) throw QString(">>> mount error!");
    if (outputStream != nullptr) {
        *outputStream<< "\n>> Finished mounting.\n" << endl;
    }
    mount->deleteLater();
    return 1;
}

int ExtPartition::unmount(const QString &suPassword, QTextStream *outputStream)
{
    QProcess *umount = new QProcess;
    umount->setProgram("bash");
    umount->setProcessChannelMode(QProcess::ForwardedChannels);
    umount->start();
    if(!umount->waitForStarted()) throw QString(">>> umount init error!");
    QString umountSuCommand = QString("echo ") + suPassword + QString(" | ") + QString("sudo -S umount -l ") + this->device + QString(" && exit \n");
    while (!umount->isOpen());
    umount->write(umountSuCommand.toUtf8());
    if (outputStream != nullptr) {
        *outputStream << "> Unmounting partition " << this->device << "..." << endl;
    }
    if(!umount->waitForFinished()) throw QString(">>> umount error!");
    if (outputStream != nullptr) {
        *outputStream<< "\n>> Finished unmounting.\n" << endl;
    }
    umount->deleteLater();
    return 1;
}

PartitionImage* ExtPartition::createImage(const QString &suPassword, const QString &exportPath, QTextStream *outputStream)
{
    QProcess *partclone = new QProcess;
    partclone->setProgram("bash");
    partclone->setProcessChannelMode(QProcess::ForwardedChannels);
    partclone->start();
    if(!partclone->waitForStarted()) throw QString("partclone init error!");
    QString uniqueImageId = QUuid::createUuid().toString();
    uniqueImageId = uniqueImageId.mid(1, uniqueImageId.length() - 2);
    QString partcloneSuCommand = QString("echo ") + suPassword + QString(" | ") + QString("sudo -S partclone.ext4 -c -d3  -s ") + this->device + QString(" -O ") + exportPath + uniqueImageId + QString(".img") + QString(" && exit \n");
    while (!partclone->isOpen());
    partclone->write(partcloneSuCommand.toUtf8());
    if (outputStream != nullptr) {
        *outputStream << "> Starting Partclone..." << endl;
    }
    if(!partclone->waitForFinished(-1)) throw QString(">>> Partclone error");
    partclone->deleteLater();
    ParentImage* result = new ParentImage(uniqueImageId, exportPath, "img", this);
    return result;
}
