#ifndef PARTITION_H
#define PARTITION_H

#include <QObject>
#include <QTextStream>

#include <partitionimage.h>

class Partition : public QObject
{
    Q_OBJECT

private:
    QString id;
    QString label;
    QString rootPath;
    int size;

public:
    explicit Partition(QObject *parent = nullptr);

    QString getId() const;
    void setId(const QString &value);

    int getSize() const;
    void setSize(int value);

    QString getLabel() const;
    void setLabel(const QString &value);

    QString getRootPath() const;
    void setRootPath(const QString &value);

    virtual int mount(const QString &suPassword, const QString &mountPoint, QTextStream *outputStream = nullptr);

    virtual int unmount(const QString &suPassword, QTextStream *outputStream = nullptr);

    virtual PartitionImage* createImage(const QString &suPassword, const QString &exportPath, QTextStream *outputStream = nullptr);

signals:

};

#endif // PARTITION_H
