#ifndef USER_H
#define USER_H

#include <QObject>
#include <QDateTime>
#include <botan-2/botan/aead.h>
#include <botan-2/botan/hex.h>

class User : public QObject
{
    Q_OBJECT

private:
    QString email;
    QString accountId;
    QDateTime createdAt;
    int usedQuota;
    QString encryptedAesKeys;
    QString apiKey;
    QString encryptedMasterKey;
    const Botan::SymmetricKey key();

public:
    explicit User(QObject *parent = nullptr);

    QString getEmail() const;
    void setEmail(const QString &value);

    QDateTime getCreatedAt() const;
    void setCreatedAt(const QDateTime &value);

    int getUsedQuota() const;
    void setUsedQuota(int value);

    QString getEncryptedAesKeys() const;
    void setEncryptedAesKeys(const QString &value);

    QString getMasterEncryptionKey(const QString &masterPassword) const;

    QString getAccountId() const;
    void setAccountId(const QString &value);

signals:

};

#endif // USER_H
