#ifndef USERSETTINGS_H
#define USERSETTINGS_H

#include <QObject>
#include <QVector>
#include <QTime>

enum WeekDay {
    Monday,
    Tuesday,
    Wednesday,
    Friday,
    Saturday,
    Sunday
};

class UserSettings : public QObject
{
    Q_OBJECT

private:
    QVector<QString> partitionsToBackupList;
    QVector<WeekDay> backupDays;
    QVector<QTime> backupTimes;
    QTime fullBackupInterval;

public:
    explicit UserSettings(QObject *parent = nullptr);

    QVector<QString> getPartitionsToBackupList() const;
    void setPartitionsToBackupList(const QVector<QString> &value);

    QVector<WeekDay> getBackupDays() const;
    void setBackupDays(const QVector<WeekDay> &value);

    QVector<QTime> getBackupTimes() const;
    void setBackupTimes(const QVector<QTime> &value);

    QTime getFullBackupInterval() const;
    void setFullBackupInterval(const QTime &value);

signals:

};

#endif // USERSETTINGS_H
