var express = require('express');
var bodyParser = require('body-parser');
var os = require("os");
var assert = require('assert');

var MongoClient = require('mongodb').MongoClient;
var ObjectID = require('mongodb').ObjectID;
var Long = require('mongodb').Long;

// Connection URL
var url = 'mongodb://mongo:27017';
 
// Database Name
var dbName = 'acopioDB';

var app = express();
var hostname = os.hostname();

app.use(bodyParser.json()); 

app.get('/', function (req, res) {
  res.send('<html><body>Hello! You are connected to the instance: ' + hostname + '</body></html>');
});

app.post('/api/users/:userId/files', function (req, res) {
  // Save file metadata
  MongoClient.connect(url, function(err, client) {
    assert.equal(null, err);

    let db = client.db(dbName);
    let collection = db.collection('userfiles');
    collection.insertOne({
      "userId": ObjectID("5ee21d6c3ade30495a7c0b22"),
      "fileIdentifier": req.body['fileId'].trim(),
      "path": "",
      "fileExtension": req.body['fileExtension'].trim(),
      "size": Long.fromNumber(0),
      "encryptedAesKey": req.body['encryptedAesKey'].trim(),
      "encryptedInitVector": req.body['encryptedInitVector'].trim(),
      "3rdPartyProvider": "awsglacier",
      "createdAt": Long.fromNumber(1591826400000),
      "uploadedAt": new Date(1591826400000).toISOString()
    },
    function(err, result) {
      assert.equal(err, null);
      assert.equal(1, result.result.n);
      assert.equal(1, result.ops.length);
      console.log("Inserted 1 document into the collection => " + collection);

      let responseJson = {
        "status": 1,
        "uploadPath": "/mnt/raid5toshiba/UserBackups"
      };
      res.send(JSON.stringify(responseJson));
      client.close();
    });
  });
});

app.listen(80);
console.log('Running on http://localhost');
